import { RdDUtility } from "../rdd-utility.js";
import { RdDBaseActorSheet } from "./base-actor-sheet.js";

/* -------------------------------------------- */
export class RdDActorVehiculeSheet extends RdDBaseActorSheet {

  /** @override */
  static get defaultOptions() {
    RdDUtility.initAfficheContenu();

    return mergeObject(super.defaultOptions, {
      classes: ["rdd", "sheet", "actor"],
      template: "systems/foundryvtt-reve-de-dragon/templates/actor-vehicule-sheet.html",
      width: 640,
      height: 720,
      tabs: [{ navSelector: ".sheet-tabs", contentSelector: ".sheet-body", initial: "carac" }],
      dragDrop: [{ dragSelector: ".item-list .item", dropSelector: undefined }]
    });
  }

  /* -------------------------------------------- */
  async getData() {
    let formData = await super.getData();
    mergeObject(formData,
      {
        editable: this.isEditable,
        cssClass: this.isEditable ? "editable" : "locked",
        effects: this.actor.effects.map(e => foundry.utils.deepClone(e)),
        limited: this.actor.limited,
        owner: this.actor.isOwner,
      });

    this.timerRecherche = undefined;
    return formData;
  }

  activateListeners(html) {
    super.activateListeners(html);
    if (!this.options.editable) return;

    this.html.find('.resistance-moins').click(async event => {
      this.actor.vehicleIncDec("resistance", -1);
    });
    this.html.find('.resistance-plus').click(async event => {
      this.actor.vehicleIncDec("resistance", 1);
    });
    this.html.find('.structure-moins').click(async event => {
      this.actor.vehicleIncDec("structure", -1);
    });
    this.html.find('.structure-plus').click(async event => {
      this.actor.vehicleIncDec("structure", 1);
    });
  }

}
