import { Draconique } from "./draconique.js";
import { PixiTMR } from "./pixi-tmr.js";

export class CarteTmr extends Draconique {

  constructor() {
    super();
  }

  type() { return '' }
  match(item) { return false; }
  manualMessage() { return false }
  async onActorCreateOwned(actor, item) { }

  code() { return 'tmr' }
  img() { return 'systems/foundryvtt-reve-de-dragon/styles/img/ui/tmr.webp' }

  createSprite(pixiTMR) {

    const img = PixiTMR.getImgFromCode(this.code())
    const sprite = new PIXI.Sprite(PIXI.utils.TextureCache[img]);
    // Setup the position of the TMR
    sprite.x = 0;
    sprite.y = 0;
    sprite.width = 722;
    sprite.height = 860;
    // Rotate around the center
    sprite.anchor.set(0);
    sprite.buttonMode = true;
    sprite.tmrObject = pixiTMR;

    pixiTMR.addTooltip(sprite, (e,s) => this.computeTooltip(e,s));
    pixiTMR.pixiApp.stage.addChild(sprite);
    return sprite;
  }

}
